#ifndef BBS_H
#define BBS_H

// @(#)bitswapper.h	1.3 - 98/05/06

#include "random.h"

// max number of bytes we can swap at a time
// this number was chosen because the max number of bits will be 32*8 = 256
//
#define MAXSWAPBYTES	32

class BitSwapper
{
	unsigned blocksz;	// the number of bytes we will swap : a power of 2
	unsigned niters;	// the number of swap iterations per block
	R250	rng;	// a source of random numbers

	void bbswap1 (uint8 *block, uint8 *rembits);

	void bbswapb (const uint8 *plain, uint8 *cipher);

	unsigned part (const uint8 *plain, uint8 *cipher, unsigned partsz);

public:
	BitSwapper (unsigned bsz, unsigned ni, uint32 seed) ;

	unsigned Swap (const uint8 *plain, uint8 *cipher, unsigned);

	inline unsigned BlockSize () { return blocksz; } ;
} ;

#endif
